#include <stdio.h>
#include <stdlib.h>

#define CLEAR 0
#define SET 1
#define FAIL -1
#define SUCCESS 1

typedef unsigned int word32;

/* ------------------ Types to Create VME ROD Map Local Data Base ---------- */
/* Each Slave Space of one Machine */
typedef struct{
  char   dev_id[ 60 ];        /* Slave_id */
  char   type[ 60 ];          /* Type of Slave, RAW-DMA              */
  word32 bs_addr;             /* VME Base Address where is Mapped    */
  word32 size;                /* Space in bytes available            */
  word32 am;                  /* AM used                             */
}VME_Item;

/* Each Machine */
typedef struct{
  char       id[ 50 ];        /* ROD_id                              */
  VME_Item  *vme_set;         /* Slave Features                      */
  int        no_items;        /* Number of Slaves                    */
  int        stat;            /* To Trace vme_set alloc/free         */
  char       data_base[ 60 ]; /* Slave Data Base to be Read          */
  char       os[ 60 ];        /* Machine OS drive above proccessing  */
}Item;

/* Whole Map */
typedef struct{
  Item *itm;      /* Dynamic vector of Machines playing ROD business */
  int   no_itm;   /* Number of Machines */
}App_Set;
/* ------------------------------------------------------------------------- */
/* ------------------------ Function Prototyping --------------------------- */
int Open_CFG           ( App_Set **set );
int Make_LocalDataBase ( App_Set*, char *file_id );
int Append_File        ( char* fileID, FILE* file_out, Item *itm, int key  );
int Scan_DataBases     ( App_Set** );
int Scan_File          ( char* file_id, int *no_items );

int Dump_Set           ( App_Set* );
int Create_Set         ( App_Set**, int size );
int Destroy_Set        ( App_Set* );
