#!/bin/tcsh 
#

# -- Tree Directory SetUp --------------------------------------------------- #
setenv host_target "LinuxPCBit3"
setenv root_d "$HOME/bin/LinuxCode"
setenv bin_d  "$root_d/bin"
setenv obj_d  "$root_d/rod/utils/OBJs"

if( $1 == "SetUp" ) then
    if( !( -e ${obj_d}/ ) ) then
	echo "[ Making $obj_d Directory Tree ]"
	mkdir -p $obj_d
    else
	echo "[ ${obj_d} Already Done]"
    endif
    echo "[ SetUp Done ]"
    goto Out
endif


# -- MAKE each ITEM --------------------------------------------------------- #
setenv inc_flags "-Iinclude  -Iinclude/VMEinc -Iinclude/RODdrv"
setenv LFLAGS "-L${obj_d}"
setenv CFLAGS "${inc_flags} -c"

make -rC src/ $1

Out:
unsetenv LFLAGS inc_flags bin_d root_d obj_d host_target

# --------------------------------------------------------------------------- #
