#include <LocalDB_Prod.h>
#define VMEFile "/home/juanba/tmp/LinuxPC/VME.cfg"
#define RODdb   "/home/juanba/tmp/LinuxPC/HardwareROD.db.dat"

int
main( ){
App_Set *set;

 if( Open_CFG( &set ) != SUCCESS ){
   printf("\n[ Can NOT Proccess %s ]\n", VMEFile );
   return( FAIL );
 }
 Dump_Set( set );
 
 if( Scan_DataBases( &set ) != SUCCESS ){
   printf("\n[ Error Proccessing DataBases ]" );
   Destroy_Set( set );
   return( FAIL );
 }

 printf("\n[ Data Bases are OK.... ][ Making Linux Data Base.. ]\n" );
 if( Make_LocalDataBase( set, RODdb ) != SUCCESS ){
   printf("\n[ Error Making Local DataBase ]" );
   Destroy_Set( set );
   return( FAIL );
 }

 Destroy_Set( set );
 printf("\n[ Nice ROD session ]\n");
 return( SUCCESS );
 
}
/* ------------------------------------------------------------------------- */

int
Open_CFG( App_Set **set ){
int ii, status;
FILE *file;
char dummy1[ 50 ], dummy2[ 50 ], dummy3[ 50 ];

 ii = CLEAR; 
 file = fopen( VMEFile, "r" );
 if( file  == NULL ){
   printf("\n[ Can NOT Open %s ]", VMEFile );
   return( FAIL );
 }
 while( SET ){
   status = fscanf( file, "%s\t%s\t%s\n", dummy1, dummy2, dummy3 );
   if( ( status != EOF )&&( status == 3 ) )
     ii++;
   else
     if( status == EOF )
       break;
     else{
       printf("\n[ %s improper Format @ raw %d ]", VMEFile, ii );
       fclose( file );
       return( FAIL );
     }
 }

 fclose( file );
 if( Create_Set( set, ii ) != SUCCESS )
   return( FAIL );

 file = fopen( VMEFile, "r" );
 for( ii = 0; ii < ( *set )->no_itm; ii++ ){
   fscanf( file, "%s\t%s\t%s", 
	   ( *set )->itm[ ii ].id, 
	   ( *set )->itm[ ii ].os, 
	   ( *set )->itm[ ii ].data_base );
 }
 fclose( file );
 return( SUCCESS );

}

int
Make_LocalDataBase( App_Set *set, char *file_id ){
#define LOCAL 1
#define REMOTE 2
char     header[]=
"# File Format:
# machine[tab]dev_id[tab]Device Type[tab]VMEbase Address[tab]VME am[tab]size
#[ tab ]LynxOS PhysicalMem. ID
# Notes:
# VME Base address & AM codes are hexadecimal
# Real size is size*32bits and decimal
$Init$
";
Item *item;
char  data_base[ 50 ];
int   ii, status, key;
FILE *file;

 status = SUCCESS; 
 if( ( file = fopen( file_id, "w" ) ) == NULL ){
   printf("\n[ %-20s ][ %-20s ]\n", "Can Not Open", file_id );
   return( FAIL );
 }
 fprintf( file, "%s", header );
 for( ii = 0 ; ii <  set->no_itm; ii++ ){
   item = &set->itm[ ii ];
   sprintf( data_base, "%s",  set->itm[ ii ].data_base );
   if( strcmp( set->itm[ ii ].id, "Local" ) == 0 ){
     key = LOCAL;
   }
   else
     key = REMOTE;
   if( Append_File( data_base, file, item, key ) != SUCCESS ){
     printf("\nCan not APPEND %s to Local Data Base ]", file_id );
     status = FAIL;
     break;
   }
 }
 fclose( file );
 return( status );

}


int
Append_File( char* fileID, FILE* file_out, Item *itm, int key  ){
int ii, status;
char machine[ 20 ], fuck_dummy[ 20 ];
FILE *file_in;

 if( ( file_in = fopen( fileID, "r" ) ) == NULL ){
   printf("\n[ %-20s ][ %-20s ]\n", "Can Not Open", fileID );
   return( FAIL );
 }
 status = SUCCESS;
 for( ii = 0 ; ii <  itm->no_items ; ii++ ){
   fscanf( file_in,"%s\t%s\t%s\t%s\t$%08x\t%d\n",
	   machine,
	   itm->vme_set[ ii ].dev_id,
	   itm->vme_set[ ii ].type,
	   fuck_dummy,
	   &( itm->vme_set[ ii ].bs_addr ),
	   &( itm->vme_set[ ii ].size )
	   );
   if( key == REMOTE ){
     if( strcmp( itm->vme_set[ ii ].type, "RAW" ) == 0 ){
       sprintf( itm->vme_set[ ii ].type, "%s","mst_VME" );
       itm->vme_set[ ii ].am = 0x09;
     }
     else
       if( strcmp( itm->vme_set[ ii ].type, "DMA" ) == 0 ){
	 sprintf( itm->vme_set[ ii ].type, "%s", "dma_VME" );
	 itm->vme_set[ ii ].am = 0x0f;
       }
   }
   else{
     itm->vme_set[ ii ].am = 0x0f;
     sprintf( itm->vme_set[ ii ].type, "%s", "slv_VME" );
     sprintf( machine, "%s", "localhost" );
   }
   fprintf( file_out, "%s\t%s\t%s\t$%08x\t$%02x\t%d\t%s\n",
	    machine,
	    itm->vme_set[ ii ].dev_id, 
	    itm->vme_set[ ii ].type, 
	    itm->vme_set[ ii ].bs_addr, 
	    itm->vme_set[ ii ].am,
	    itm->vme_set[ ii ].size,
	    fuck_dummy
	    );
 }
 fclose( file_in );
 return( status );

}


int
Scan_DataBases( App_Set **set ){
int  ii, status, *no_items;
char file_id[ 50 ];

 status = SUCCESS;
 for( ii = 0 ; ii < ( *set )->no_itm ; ii++ ){
   no_items = &( ( *set )->itm[ ii ].no_items );
   sprintf( file_id, "%s",  ( *set )->itm[ ii ].data_base );
   if( Scan_File( file_id, no_items ) == FAIL ){
     printf("\n[ Data Base %s SCAN ][ FAILs ]", file_id );
     return( FAIL );
   }
   ( *set )->itm[ ii ].vme_set =( VME_Item* )
     malloc( sizeof( VME_Item ) * ( *no_items ) );
   if( ( *set )->itm[ ii ].vme_set == NULL ){
     printf("\n[ Data Base %s Alloc ][ FAILs ]", file_id );
     return( FAIL );
   }
   ( *set )->itm[ ii ].stat = SET;
 }
 return( status );

}  


int
Scan_File( char* file_id, int *no_items ){
FILE *file;
int count = CLEAR, status;
char dummy0[ 20 ], dummy1[ 20 ], dummy2[ 20 ], dummy3[ 20 ];
word32 dummy4, dummy5;

 if( ( file = fopen( file_id, "r" ) ) == NULL ){
   printf("\n[ %-20s ][ %-20s ]\n", "Can Not Open", file_id );
   return( FAIL );
 }
 printf("\n[ %-10s ][ %-15s ]", "Proccessing:", file_id );
 /* At this level we are only interested in the format file quality &
    count value */
 while( SET ){
   status = fscanf( file, "%s\t%s\t%s\t%s\t$%08x\t%d", 
		    dummy0, dummy1, dummy2, dummy3, &dummy4, &dummy5 );
   if( status == 6 ){
     count++;
     continue;
   }
   else{
     if( status == EOF )
       break;
     else{
       printf("\n[ Ilegal Format ]");
       return( FAIL );
     }
   }
 }
 *no_items = count;
 status = SUCCESS;
 printf("\n[ Detected %d VME items ]", count );
 printf("\n[ Temporally Alloc SUCCESS ]" );
 fclose( file );
 return( status );

}


int
Dump_Set( App_Set *set ){
int ii;

 for( ii = 0; ii < set->no_itm; ii++ ){
   printf( "\n[ %-12s ][ %-12s ][ %-20s ]",
	   set->itm[ ii ].id, set->itm[ ii ].os, set->itm[ ii ].data_base );
 }
 printf("\n");
 return( SUCCESS );

}


int
Create_Set( App_Set **set, int size ){
int status;
int ii;

 status = FAIL; 
 *set = ( App_Set* )malloc( sizeof( App_Set ) );
 if( *set == NULL )
   status = FAIL;
 else{
   status = SUCCESS ;
   ( *set )->no_itm = size;
 }

 ( *set )->itm = ( Item* )malloc( sizeof( Item )* size );
 if( ( *set )->itm == NULL ){
   free( set );
   return( FAIL );
 }

 for( ii = 0; ii < size; ii++ ){
   ( *set )->itm[ ii ].stat = CLEAR;
 }
 return( status );

}


int
Destroy_Set( App_Set *set ){
int ii;
Item *itm;
  
  itm = &( set->itm[ 0 ] ); 
  for( ii = 0 ; ii < set->no_itm ; ii++ ){
    if( itm[ ii ].stat == SET ){
      printf("\n[ Releasing Memory for %s ]", itm[ ii ].id );
      free( set->itm[ ii ].vme_set );
    }
  }
  free( set->itm );
  free( set ); 
  printf("\n");
  return( SUCCESS );

}
