#!/bin/tcsh 
#

printf "\n[ROD-Target]:\n\t$1\n"
setenv Host_Libs "libVMEUniverse.a"
setenv obj_d "$root_d/rod/$1/OBJs"
setenv LFLAGS "-mposix4d9 -mthreads -lVMEUniverse"
setenv inc_flags "-Iinc -Iinc/UIO3.0 -Iinc/Universe"

if( $1 == "module" ) then
  setenv Host_Libs "${Host_Libs} libSlinkMVME2604.a"
  setenv LFLAGS "$LFLAGS -lSlinkMVME2604"
  setenv inc_flags "${inc_flags} -Iinc/SlinkMVME2604"
  setenv inc_flags "${inc_flags} -Iinc/SlinkMVME2604/PCIinc"
endif


if( $2 == "SetUp" ) then
# Checking the ROD-Target object directory
  if( !( -e ${obj_d}/ ) ) then
     printf "Making: -= ROD:$1 =- Directory Tree"
     mkdir -p $obj_d
  else
     printf "Directory Tree:\n\t${obj_d}\n\tAlready Done\n"
  endif

# Checking the VMElib Stuff    
  if( !( -e ${obj_d}/libVMEUniverse.a ) ) then
     printf "Making VME Link:\n\t${obj_d}/libVMEUniverse.a\n"
     ln -s ${root_d}/VMElib/OBJs/libVMEUniverse.a ${obj_d}/libVMEUniverse.a
  else
     printf "VMElib Link:\n\t${obj_d}/libVMEUniverse.a\n\tAlready Done\n"
  endif

# Checking the Slink Stuff if "module" is the ROD-target
  if( $1 == "module" ) then
     if( !( -e ${obj_d}/libSlinkMVME2604.a ) ) then
      printf "Making Slink Link:\n\t${obj_d}/libSlinkMVME2604.a\n"
      ln -s ${root_d}/Slink/OBJs/libSlinkMVME2604.a ${obj_d}/libSlinkMVME2604.a
    else
      printf "Slinklib Link:\n\t${obj_d}/libSlinkMVME2604.a\n\tAlready Done\n"
    endif
  endif
else
# Something To Build
  make -rC src/$1 $2
endif

unsetenv LFLAGS inc_flags obj_d Host_Libs
