#!/bin/tcsh 
#

printf "\n[ROD-Target]:\n\t$1\n"
setenv Host_Libs "libVMEBit3.a"
setenv obj_d "$root_d/rod/$1/OBJs"
setenv LFLAGS "-lVMEBit3 -lpthread"
setenv inc_flags "-Iinc -Iinc/Bit3Linux -Iinc/Bit3Linux/RODdrv"

if ($1 == "front_end") then 
    setenv Host_Libs "${Host_Libs} libSlinkLinux.a"
    setenv LFLAGS "${LFLAGS} -lSlinkLinux"
    setenv inc_flags "${inc_flags} -Iinc/SlinkLinux"
endif

if( $2 == "SetUp" ) then
# Checking the ROD-Target object directory
    if( !( -e ${obj_d}/ ) ) then
	printf "[ %-35s ]\n" "Making: -= ROD-$1 =- Directory Tree"
	mkdir -p $obj_d
    else
	printf "Directory Tree:\n\t${obj_d}\n\tAlready Done\n"
    endif

# Checking the VMElib Stuff 	    
    if( !( -e ${obj_d}/libVMEBit3.a ) ) then
	printf "Making VME Link:\n\t${obj_d}/libVMEBit3.a\n"
	ln -s ${root_d}/Bit3/OBJs/libVMEBit3.a ${obj_d}/libVMEBit3.a
    else
	printf "VMElib Link:\n\t${obj_d}/libVMEBit3.a\n\tAlready Done\n"
    endif

# Checking the Slink Stuff if "front_end" is the ROD-target
    if( $1 == "front_end" ) then
	if( !( -e ${obj_d}/libSlinkLinux.a ) ) then
	  printf "Making Slinklib Link:\n\t${obj_d}/libSlinkLinux.a\n"
	  ln -s ${root_d}/Slink/OBJs/libSlinkLinux.a ${obj_d}/libSlinkLinux.a
	else
	  printf "Slinklib Link:\n\t${obj_d}/libSlinkLinux.a\n\tAlready Done\n"
	endif
    endif

else
# Something to build...
   make -rC src/$1 $2
endif

unsetenv LFLAGS inc_flags obj_d Host_Libs  
