#ifndef __COMMANDsINC__
#define __COMMANDsINC__

/* Module Commands --------------------------------------------------------- */
#define MASK_COMMAND 0x1
#define CMD_RECEIVED 0x2
#define ACK_1        0xa0 /* Not Configured                    */
#define ACK_2        0xa1 /* Already Running                   */
#define ACK_3        0xa2 /* Injection Down                    */
#define ACK_4        0xa3 /* Not Running                       */
#define ACK_5        0xa4 /* Machine-Internal Fail             */
#define ACK_6        0xa5 /* Invalid Config Params             */
#define ACK_7        0xa6 /* Already Running STOP-PAUSE Before */

#define RUN          0x4
#define PAUSE        0x5
#define CONFIG       0x6
#define CONTINUE     0x7
#define SHUTDOWN     0x8
#define SAMPLE       0x9
#define STOP         0xa

/* Data Injection Values -------------------------------------------- */
#define __DMAOn__          0xc
#define __DMAOff__         0xd
#define __TriggerOn__      0xa
#define __TriggerOff__     0xb
#define __TriggerTimeOut__ 100
#define __DataSRCFail__    1000

#define __IUHandshake__    40    /* CSR-Offset for Data Injection Handshakes */
#define __OUHandshake__    51    /* Idem than above for Output Flow          */


/* Configuration Word  ---------------------------------------------- */
#define __NoChannels__     50
#define __NoSamples__      8
#define __cfgOffset__      3

#define __ConfigPackSize__ 3

#define __NoneTRG__       0
#define __TTC__           1
#define __AutoTRG__       2
#define __ControllerTRG__ 3

/* I/O Source */
#define __Controller__  0
#define __FrontEnd__    1
#define __Module__      2

/* I/O Type */
#define __Slink__ 0
#define __VME__   1
#define __Auto__  2

/* I/O Mode */
#define __Target__     0
#define __Driver__     1

/* Format_ID */
#define __Calibration__ 0
#define __ATLAS__       1
#define __Monitor__     2
#define __ByPass__      3

#ifndef __TypesOn__
#define __TypesOn__
typedef unsigned int       word32;
typedef unsigned short int word16;
typedef unsigned char      word8;
#endif

typedef union{
#ifdef LinuxPCBit3
  struct{
    word32 dummy1      : 8;
    word32 no_channels : 8;
    word32 no_samples  : 8;
    word32 src_type    : 1;
    word32 io_mode     : 1;
    word32 format_id   : 2;
    word32 io_type     : 2;
    word32 dummy0      : 2;
  }bit;
#endif
#if defined (MVME167_Lynx2_5_1 ) || defined( PowerPC_Lynx3_0 )
  struct{
    word32 dummy0      : 2;
    word32 io_type     : 2;
    word32 format_id   : 2;
    word32 io_mode     : 1;
    word32 src_type    : 1;
    word32 no_samples  : 8;
    word32 no_channels : 8;
    word32 dummy1      : 8;
  }bit;
#endif
  word32 all;
}Config_Word;
/* ------------------------------------------------------------------------- */

typedef union{
  struct{
    word32 config  : 1;
    word32 run     : 1;
    word32 pause   : 1;
    word32 stop    : 1;
    int    machine : 3;
    word32 dummy   :25;
  }bit;
  word32 all;
}System_State;

#endif
