/*
    $Header: ROD object interface for the TileCal ROD-Controller
    Created & Maintaned by JB. Juanba.Romance@ific.uv.es

*/
#ifndef __RODINC__
#define __RODINC__

#include <string.h>
#include "RODhardware.h"
#include "RODsoftware.h"

#define RODMap "/home/juanba/tmp/RODMap.cfg"
#define __SRCFail__ 17
#define __Busy__    0xa
#define __Ready__   0xb

/* 01/Oct/99 FrontEnd Integration starts */
/* First changes RODmap.cfg ---> RODOpen */
/* Functions And Types added on RODhardware.h to process new File Format, with 
   Multiple FrontEnd-Module Mapping capabilities */ 

typedef struct{
  word32    cfg[ __ConfigPackSize__ ];
  word32    stat;
}Crate_Config;

typedef union{
  struct{
    word8 f_1:1;
    word8 f_2:1;
    word8 f_3:1;
    word8 f_4:1;
    word8 dummy:4;
  }bit;
  word8 all;
}Handler_Filter;

int  Make_Mset          ( M_entry  *m_entry  );
int  Make_FEset         ( FE_entry *fe_entry );
int  Make_Ctrl          ( C_entry  *c_entry  );


/*+ ROD Object ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
typedef struct{
  ROD_Hardware *hardware; /*+ VME And SLink Hardware Layers +*/
  ROD_Software *software; /*+ Software Resources            +*/
  Crate_Config     *list; /*+ Module Configuration Table    +*/
  ROD_info          info;
  word32            stat;
}ROD;
int  ROD_Open           ( ROD** );
int  ROD_Close          ( ROD*  );
int  ROD_Config         ( ROD*, word32 module, word32 config_data );
int  ROD_Sampling       ( ROD*, word32 module, word32 *bs_addr ); 
void ROD_Handler        ( int sig_num );

int  Module_BroadCast   ( ROD*, word32 command );
int  Module_Command     ( ROD*, word32 item, word32 command, char *stat );
int  FEnd_BroadCast     ( ROD*, word32 cmd );
int  FEnd_Command       ( ROD*, word32 module, word32 cmd, char *stat );

int  Get_Module_Stat    ( ROD*, word32 module, word32 *state  );
void Dump_RODinfo       ( ROD* );
void Decode_CFGword     ( word32    cfg_word );
void Decode_Module_Stat ( word32   *status   );
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

#endif
