#ifndef __RODvmeINC__
#define __RODvmeINC__

/* ---------------------- Interfaces Supported by RODvme.c  ---------------- */
#ifdef LinuxPCBit3
#include <Bit3Linux.h>
#define FileID "/home/juanba/tmp/LinuxPC/HardwareROD.db.dat"
#endif

#ifdef MVME167_Lynx2_5_1
#include <VMElib.h>
#define FileID "/home/juanba/tmp/mvme167ROD/HardwareROD.db.dat"
#endif

#ifdef PowerPC_Lynx3_0
#include <VMElib.h>
#define FileID "/home/juanba/tmp/PowerROD/HardwareROD.db.dat"
#endif


#define InitKey "$Init$"
#define VME_OBJECTs 3
typedef enum{ 
  Master_VME = 1, Slave_VME, dma_VME
}VME_Object;

/* To Search on VME_Devs */
typedef struct{
   char machine[ 30 ];
   char dev_id[ 30 ];
}Search_Key;

typedef struct{
   int count;
   int offset;
}FilePar;


/* ------------------------ ROD VME Objects List --------------------------- */
/*+ Each VME Object from RODvme point of view +*/
typedef struct{
  char          id[ 35 ];       /*+ Resource Identifier            +*/
  char          machine[ 30 ];  /*+ Machine Location               +*/
  VME_Object    obj_type;       /*+ Object Type Master, Slave, DMA +*/ 
  char         *vme_obj;        /*+ Pointer to Physical VME Object +*/
  int           stat;           /*+ Memory Status                  +*/ 
}VME_Dev;

typedef struct{
#ifdef LinuxPCBit3
  Bit3CSR_Dev   *b3csr_dev; 
  Bit3PT_Dev    *b3dpt_dev;
#endif
#ifdef MVME167_Lynx2_5_1
  Chip2_Dev     *chip2_dev;
#endif
#ifdef PowerPC_Lynx3_0
  Universe_Dev  *universe_dev;
#endif
  VME_Dev       *rod_dev;
  int            no_dev;
}VME_Devs;

/*+ User Methods +*/
int  Open_RODVME       ( VME_Devs** );
int  Close_RODVME      ( VME_Devs*  );
int  Get_VMEObject     ( VME_Devs*, char *key, word32 *addr, word32* idx );

/*+ Internal methods +*/
int  Get_Params       ( char* id, char* data );
int  Read_Data_Base   ( VME_Devs* );
int  Scan_File        ( FILE*, FilePar* f_par );
int  Make_RODVME_Objs ( FILE*, VME_Devs*, FilePar* f_par );
int  Dump_Object      ( VME_Dev* );
/* ------------------------------------------------------------------------- */
#endif

