/**
    $Header: ROD Object interface for the ROD Front-End Application
    Created & Maintained by JB. Juanba.Romance@ific.uv.es $

    11/Oct/99:
    FrontEnd Integration starts.
    
    11/December/99
    Data Injection starts.

**/

#ifndef __RODINC__
#define __RODINC__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "RODhardware.h"
#include "RODsoftware.h"

#define RODMap "/home/juanba/tmp/RODMap.cfg"
#define __SRCFail__ 17
typedef struct{
  word32    cfg[ __ConfigPackSize__ ];
}MOD_Config;
typedef union{
  struct{
    word8 f_1:1;
    word8 f_2:1;
    word8 f_3:1;
    word8 f_4:1;
    word8 dummy:4;
  }bit;
  word8 all;
}Handler_Filter;

typedef union{
  struct{
    word8 pause:1;
    word8 stop:1;
    word8 run:1;
    word8 config:1;
    word8 up: 1;
    word8 dummy:4;
  }bit;
  word8 all:8;
}FEnd_stat;

/*+ ROD Object +*/
typedef struct{
  ROD_Hardware *hardware; /*+ Hardware Layers: VME-Slink    +*/
  ROD_Software *software; /*+ Software Resources            +*/
  MOD_Config   *list;     /*+ Module Configuration Table    +*/
  ROD_info      info;
  word32        mi_stat;  /*+ Module Injection status       +*/     
  FEnd_stat     fe_stat;  /*+ FrontEnd Status               +*/
}ROD;

int  ROD_Open     ( ROD** );
int  ROD_Close    ( ROD* );
int  ROD_SetUp    ( ROD* );
int  ROD_Run      ( ROD* );
int  ROD_Stop     ( ROD* );
int  ROD_Config   ( ROD*, word32 *cfg_word );

int  Make_Ctrl    ( C_entry*   );
int  Make_FE      ( FE_entry*  );
int  Make_Module  ( FE_entry*  );
void RODinfo_Dump ( ROD*       );
int  Ptr_Checking ( ROD*       );
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


#endif
