/****
     Object Interface Barrier-Machine version for the Distribution Unit
*****/
 
#ifndef __DUnitINC__
#define __DUnitINC__

#include "Common.h"

/*+ Distribution Unit Object +*/
typedef struct{
  char              id[ 20 ];
  int               hit;       /*+ Current BCID Event Tag              +*/
  w32               nopu;      /*+ Number of PUs                       +*/
  PUnit            *unit;      /*+ Pointer to PU Farm                  +*/
  
  pthread_t         phy_th;    /*+ Physical Thread                     +*/
  pthread_mutex_t  *iu_mtx;    /*+ Ptr to Input Buffer Mutex           +*/
  pthread_cond_t   *iu_cv;     /*+ Ptr to IU condition variable        +*/

  pthread_mutex_t   ib_mtx;    /*+ ibuffer barrier mutex               +*/
  pthread_cond_t    ib_cv;     /*+ ibuffer cv                          +*/
  pthread_cond_t    du_cv;     /*+ DUnit cv                            +*/
  int               i_barrier; /*+ ibuffer barrier counter             +*/

  int               du_ready; 
  int              *iu_ready;

  w32              *quit;      /*+ Pointer to Quit Flag                +*/
  int              *stat;      /*+ Pointer to IU State on ROD Machine  +*/
  TTC_Info         *ttc_info;  /*+ TTCInfo                             +*/
  w32              *i_buf;     /*+ Pointer to Input Buffer             +*/
  
}Distribution_Unit;
int DU_Open   ( Distribution_Unit* );
int DU_Close  ( Distribution_Unit* );
int DU_Run    ( Distribution_Unit* );
int DU_Engine ( void* );

#endif
