#ifndef __EBUnitINC__
#define __EBUnitINC__

#include "Common.h"

#define ATLAS_HEADER_SIZE    0x09
#define H_MARKER             0xEEEEEEEE
#define ATLAS_FORMAT_VERSION 0xDeadBeef
#define ROD_MODULE_ID        0xFabada

/*+ Event Builder Object +*/
typedef struct{
  int               hit;
  char              id[ 20 ];
  w32               nopu;      /*+ Number of PUs                   +*/
  PUnit            *unit;      /*+ Pointer to PU Farm              +*/

  pthread_t         phy_th;    /*+ Physical Thread                 +*/   
  pthread_mutex_t   ebu_mtx;   /*+ EBU Mutex                       +*/
  pthread_cond_t    ebu_cv;    /*+ EBU condition variable          +*/
  
  pthread_mutex_t   ob_mtx;    /*+ obuffer Barrier Mutex           +*/
  pthread_cond_t    ob_cv;     /*+ obuffer Barrier cv              +*/
  pthread_cond_t    pu_cv;     /*+ Punit cv                        +*/
  int               o_barrier; /*+ obuffer Barrier index           +*/

  w32              *ou_ready;  /*+ Ptr to OUready flag             +*/
  w32               ebu_ready; /*+ EBU ready flag                  +*/

  w32              *o_buf;
  w32              *quit;      /*+ Pointer to Quit Flag            +*/
  int              *stat;      /*+ Pointer to IU State on Machine  +*/
  TTC_Info         *ttc_info;  /*+ TTCInfo                         +*/

}Event_Builder_Unit;
int EBU_Open         ( Event_Builder_Unit* );
int EBU_Close        ( Event_Builder_Unit* );
int EBU_Run          ( Event_Builder_Unit* );
int EBU_Engine       ( void* );
int Make_ATLAS_Event ( w32* ptr, TTC_Info *ttc_info );


#endif
