/**** 
   $Header: Object Interface Barrier-Machine version for Machine object
   Created & Maintaned by JB. Juanba.Romance@ific.uv.es $
   Nomenclature:
 
    DU  Distribution Unit

    IU  Input Unit
    
    PU  Processor Unit
    
    CU  Controller Unit
    
    EBU Event Builder Unit 
   
    08/November/99: Integration Starts for the Barrier Version
 
******/

#ifndef __MachineINC__
#define __MachineINC__

#include "Common.h"
#include "DUnit.h"
#include "IUnit.h"
#include "PUnit.h"
#include "EBUnit.h"
#include "OUnit.h"
#include "TTCUnit.h"

/*+ ROD Machine Object +*/
#define MACHINE_READY     SET
#define MACHINE_RUNNING ( SET+1 )
#define MACHINE_DOWN    ( SET+2 )
#define MACHINE_UP      ( SET+3 )

typedef struct{
  Input_Unit          iu;
  Distribution_Unit   du;
  Processor_Unit      pu;
  Event_Builder_Unit  ebu;
  OutPut_Unit         ou;
  TTC_Unit            ttc;
  Arch_State          mch_stat;
  System_State       *sys_stat;
  w32                 cfg[ 10 ]; /*+ Machine Configuration     +*/
  w32                 l_csr;     /*+ local CSR Virtual Address +*/
  w32                 trg_veto;
}Machine;

int Machine_Open    ( Machine** , w32 csr_addr, w32 sys_addr );
int Machine_Close   ( Machine* );
int Machine_RunBaby ( Machine* );
int Machine_Dump    ( Machine* );
int Machine_Config  ( Machine*, w32 *cfg_data );
#endif
