/*
    $Header: ROD Object interface for the ROD Module Application
    Created & Maintaned by JB. Juanba.Romance@ific.uv.es
    03/November/99 Front-End Integration starts
*/

#ifndef __RODINC__
#define __RODINC__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "RODhardware.h"
#include "RODsoftware.h"

#define RODMap "/home/juanba/tmp/RODMap.cfg"
typedef union{
  struct{
    word8 f_1:1;
    word8 f_2:1;
    word8 f_3:1;
    word8 f_4:1;
    word8 dummy:4;
  }bit;
  word8 all;
}Handler_Filter;

/*+ ROD Object ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
typedef struct{
  ROD_Hardware *hardware; /*+ VME And SLink Hardware Layers +*/
  ROD_Software *software; /*+ Software Resources            +*/
  ROD_info         info;
  System_State     sys_stat;
}ROD;

int  ROD_Open     ( ROD** );
int  ROD_Close    ( ROD*  );
int  ROD_Dump     ( ROD*  );
int  ROD_Run      ( ROD*  );
int  ROD_Stop     ( ROD*  );
int  ROD_Config   ( ROD*, word32* cfg_data );

int  Make_Ctrl    ( Ctrl_entry* );
int  Make_FE      ( M_entry*, FE_entry* );
int  Make_Module  ( M_entry*, FE_entry* );

void Dump_RODinfo ( ROD* );
int  Ptr_Checking ( ROD* );
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

#endif
