/* RODvme for the Front-End ROD */
#ifndef __RODvmeINC__
#define __RODvmeINC__

#define SMEM_10

extern char bd[ ];
extern char us[ ];
extern char atoff[ ];

/* ---------------------- Interfaces Supported by RODvme.c  ---------------- */
#ifdef LinuxPCBit3
#include <Bit3Linux.h>
#define FileID "/home/juanba/tmp/LinuxPC/HardwareROD.db.dat"
#define __MySelf__ "147.156.2.81"
#endif

#ifdef MVME167_Lynx2_5_1
#include <VMElib.h>
#define FileID "/home/juanba/tmp/mvme167ROD/HardwareROD.db.dat"
#define __MySelf__ "147.156.2.75"
#endif

#ifdef PowerPC_Lynx3_0
#include <VMElib.h>
#define FileID "/home/juanba/tmp/PowerROD/HardwareROD.db.dat"
#define __MySelf__ "147.156.2.73"
#endif
/* ------------------------------------------------------------------------- */

#define InitKey "$Init$"
#define VME_OBJECTs 3
typedef enum{ 
  Master_VME = 1, Slave_VME, dma_VME
}VME_Object;

/* To Search on VME_Devs */
typedef struct{
  char machine[ 30 ];
  char dev_id[ 30 ];
}Search_Key;

typedef struct{
  int count;
  int offset;
  int entries;
}FilePar;

/* 07 December/99.  */
/*+ Data types to interface HardwareROD.db.dat +*/
typedef struct{
  char    id[ 20 ];
  char    ip_addr[ 20 ];
}FE_entry;

typedef struct{
  char   id[ 20 ];
  char   ip_addr[ 20 ];
}Ctrl_entry;

typedef struct{
  char   id[ 20 ];
  char   ip_addr[ 20 ];
  word32 fe_idx;
  word32 ctrl_idx;
}M_entry;

typedef struct{
  FE_entry fe;
  Ctrl_entry  ctrl;
  M_entry  mod;
}ROD_info;


/* ------------------------ ROD VME Objects List --------------------------- */
/* Each VME Object from RODvme point of view */
typedef struct{
  char          id[ 35 ];       /* Resource Identifier            */
  char          machine[ 30 ];  /* Machine Location               */
  VME_Object    obj_type;       /* Object Type Master, Slave, DMA */ 
  char         *vme_obj;        /* Pointer to Physical VME Object */
  int           stat;           /* Memory Status                  */ 
}VME_Dev;

typedef struct{
#ifdef LinuxPCBit3
  Bit3CSR_Dev   *b3csr_dev; 
  Bit3PT_Dev    *b3dpt_dev;
#endif
#ifdef MVME167_Lynx2_5_1
  Chip2_Dev     *chip2_dev;
#endif
#ifdef PowerPC_Lynx3_0
  Universe_Dev  *universe_dev;
#endif
  VME_Dev       *rod_dev;
  int            no_dev;
}VME_Devs;

/* Public Methods */
int  Open_RODVME       ( VME_Devs** , word32 info_ptr );
int  Close_RODVME      ( VME_Devs*  );
int  Get_VMEObject     ( VME_Devs*, char *key, word32 *ptr, word32* idx );
int  Get_VME_Event     ( VME_Devs* );
int  Set_VME_Event_Obj ( VME_Devs*, word32 idx );

/* Internal methods */
int  Get_Params       ( char* id, char* data );
int  Read_Data_Base   ( VME_Devs*, word32 info_ptr );
int  Scan_File        ( FILE*, FilePar* f_par, word32 info_ptr );
int  Make_RODVME_Objs ( FILE*, VME_Devs*, FilePar* f_par, word32 info_ptr );
int  Dump_Object      ( VME_Dev* );
/* ------------------------------------------------------------------------- */
#endif

