/***
    $Header: TTCUnit.h Barrier version for the RODModule Application
    Created & Maintaned by JB. Juanba.Romance@ific.uv.es $
   
****/

#ifndef __TTCUnitINC__
#define __TTCUnitINC__

#include "Common.h"

#define TYPE_1 0xFabadaca
#define TRG_ON 0xccdebaca


/*+ TTC Unit Interface  +*/
typedef struct{
  char              id[ 20 ];
  w32               trg_mode;
  w32              *trg_veto;  /*+ Pointer to Global Trigger VETO */
  w32               hit;

  pthread_cond_t   *iu_cv;     /*+ Pointer to IU control variable +*/
  pthread_t         phy_th;    /*+ Physical Thread                +*/   
  pthread_mutex_t   ttc_mtx;   /*+ TTC Mutex                      +*/
  pthread_cond_t    ttc_cv;    /*+ TTC cv                         +*/

  pthread_mutex_t  *b_mtx;     /*+ Pointer to barrier mutex       +*/
  pthread_cond_t   *b_cv;      /*+ Pointer to barrier cv          +*/
  int              *barrier;   /*+ Barrier counter                +*/

  w32              *busy;      /*+ Pointer to IU->stat flag       +*/
  int              *stat;      /*+ Pointer to TTC Unit State Flag +*/
  w32              *quit;      /*+ Pointer to Quit Flag           +*/
  TTC_Info          info;

  w32              *l_csr;
  w32              *r_csr;
  
}TTC_Unit;
int  TTC_Open    ( TTC_Unit* );
int  TTC_Close   ( TTC_Unit* );
int  TTC_Run     ( TTC_Unit* );
int  TTC_Engine  ( void*     );
int  Get_timing  ( w32 *wait );
void AutoClean   ( TTC_Unit* );

#endif
