#!/bin/tcsh

setenv ROOT_D  ${HOME}/usr/src/RodCode
setenv CTRL_D  ${ROOT_D}/html/controller
setenv FE_D    ${ROOT_D}/html/front_end
setenv MOD_D   ${ROOT_D}/html/module
setenv CTRL_RD ${ROOT_D}/src/controller
setenv FE_RD   ${ROOT_D}/src/front_end
setenv MOD_RD  ${ROOT_D}/src/module

mkdir -p ${CTRL_D}
mkdir -p ${FE_D}
mkdir -p ${MOD_D}


printf "Making ROD-Code Documentation....\n"
switch($1)
    
    case "module":
	printf "[ %-40s ]\n" "RODModule-mvme2604"
	cd ${MOD_RD}
	setenv INC_REF_FLAGs "-I./inc -I./inc/UIO3.0 -I./inc/Universe"
	setenv INC_REF_FLAGs "${INC_REF_FLAGs} -I./inc/SlinkMVME2604/PCIinc"
	setenv INC_REF_FLAGs "${INC_REF_FLAGs} -I./inc/SlinkMVME2604"
	cxref *.c ./inc/*.h  ${INC_REF_FLAGs} -xref-all -index-all -O${MOD_D} \
-DPowerPC_Lynx3_0 -D__LynxOSdoc__ -NModule-mvme2604 -html32-src 
    breaksw

    case "front_end":
	cd ${FE_RD}
	printf "[ %-40s ]\n" "FrontEnd-LinuxPC"
	setenv INC_REF_FLAGs "-I./inc -I./inc/Bit3Linux"
	setenv INC_REF_FLAGs "${INC_REF_FLAGs} -I./inc/Bit3Linux/RODdrv"
	setenv INC_REF_FLAGs "${INC_REF_FLAGs} -I./inc/SlinkLinux"
	cxref *.c ./inc/*.h ${INC_REF_FLAGs} -xref-all -index-all -O${FE_D} \
-DLinuxPCBit3 -NFrontEnd-LinuxPC -html32-src
    breaksw

    case "controller":
	cd ${CTRL_RD}
	printf "[ %-40s ]\n" "RODController-mvme167"
	setenv INC_REF_FLAGs "-I./inc -I./inc/UIO2.5.1 -I./inc/VMEchip2"
	cxref *.c ./inc/*.h ${INC_REF_FLAGs} -xref-all -index-all \
-DMVME167_Lynx2_5_1 -O${CTRL_D} -D__LynxOSdoc__ -NController-mvme167 \
-html32-src
    breaksw
    
endsw


unsetenv INC_REF_FLAGs MOD_RD CTRL_RD FE_RD CTRL_D FE_D MOD_D

