#!/bin/tcsh 
#


switch($1)

 case "help"
 case "--help"
 case "-h"
help:
    printf "\n1st-> Make an alias of <source runmake.csh> called i.e <doit>"
    printf "\nif you don't have one yet ;-)"
    printf "\n\nGeneral call format: doit [RODtarget] [RODapp] [service]"
    printf "\n\tValid -RODtarget- values : LinuxPC,MVME2604,MVME167"
    printf "\n\tValid -RODapp- values    : controller,front_end,module,SetUp"
    printf "\n\tValid -service- values   : all, clean, SetUp\n\n"
    goto bye
 breaksw

 case "LinuxPC"
    setenv root_d      "$HOME/bin/LinuxCode"
    setenv script      "i686-linux-2.2.12-20.csh"
    setenv host_target "LinuxPCBit3"
 breaksw

 case "MVME2604"
    set UserPath=$PATH
    setenv root_d      "$HOME/bin/LynxOSCode/MVME2604"
    setenv script      "MVME2604-ppc-lynx-3.0.csh"
    setenv host_target "PowerPC_Lynx3_0"
    setenv environment "/lynx/3.0.0/ppc/SETUP.csh"
 breaksw

 case "MVME167"
    set UserPath=$PATH
    setenv root_d      "$HOME/bin/LynxOSCode/MVME167"
    setenv script      "MVME167-68k-lynx-2.5.1.csh"
    setenv host_target "MVME167_Lynx2_5_1"
    setenv environment "/lynx/2.5.1/68k/SETUP.csh"
 breaksw
 default
    printf "\nFirst Argument: Invalid value\n"
    goto help
endsw

printf "# ------------------= Setting Up Environment =-------------------- #\n"
setenv bin_d       "$root_d/bin"

switch($2)
  case "all"
# Check if we Cross-compiling is requested 
    if( $1 == "MVME2604" || $1 == "MVME167" ) then
	source ${environment}
    endif
    source ${script} controller $3
    source ${script} front_end  $3
    source ${script} module     $3
    unsetenv environment
  breaksw

  case "SetUp"
    if( !( -e ${bin_d}/ ) ) then
      printf "\nMaking Tree:\n\t$bin_d"
      mkdir -p $bin_d
    else
      printf "\nTree:\n\t$bin_d\n\tAlready done\n"
    endif
  breaksw

  case "controller"
  case "front_end"
  case "module"
# Check if Cross-compiling is requested 
    if( $1 == "MVME2604" || $1 == "MVME167" ) then
	source ${environment}
    endif
    source ${script} $2 $3
    unsetenv environment
       
  breaksw
endsw
printf "# -------------------= Environment Restored =--------------------- #\n"

unsetenv host_target root_d bin_d script
if( $1 == "MVME2604" || $1 == "MVME167" ) then
    setenv PATH "${UserPath}"
    unset  UserPath MANPATH PW_CSH
    unsetenv CFLAGS NO_RTN HPATH ENV_PREFIX OBJSFORMAT LYNXTARGET
    unsetenv HOSTER_USR_DIR HOSTER_TOOLS_DIR
endif

bye:
exit 0

    
