/**
    $Header: ROD Crate Controller Main Thread. Created & Maintained by JB. 
    Juanba@ific.uv.es $

    10/July/1999: Documented Version
**/


#include "ROD.h"

char bd[ ] = { 27, 91, 49, 109, 0 };
char us[ ] = { 27, 91, 49, 27, 91, 52, 109,0 };
char atoff[ ] = { 27, 91, 48, 109, 0 };

int Show_Event( word32 evt_ba );


/* ----------------------- RODcontroller Main Thread ----------------------- */
int
main( int argc, char *argv[ ] ){
ROD        *rod;
word32      evt_ba;
Config_Word cfg[ __ConfigPackSize__ + 2 ];
char        status[ 40 ];

 if( ROD_Open( &rod ) != SUCCESS ){
   Dump_RODinfo( rod );
   printf("\n[ %-30s ]\n", "ROD Open: FAIL" );
   ROD_Close( rod );
   printf("\nBye, ;-)\n");
   fflush( stdout );
   return( FAIL );
 }
#ifdef VERBOSE
 printf("\n[ %-20s ]", "ROD Open: SUCESS");
 fflush( stdout );
#endif
 
 cfg[ 0 ].all             = __ConfigPackSize__ ;
 cfg[ 1 ].all             =   CLEAR;
 cfg[ 1 ].bit.io_mode     = __Target__ ;
 cfg[ 1 ].bit.src_type    = __FrontEnd__ ;
 cfg[ 1 ].bit.no_channels = __NoChannels__ ;
 cfg[ 1 ].bit.no_samples  = __NoSamples__ ;
 cfg[ 1 ].bit.io_type     = __Slink__ ;
 cfg[ 1 ].bit.format_id   = __Monitor__ ;

 cfg[ 2 ].all             =   CLEAR;
 cfg[ 2 ].bit.io_mode     = __Target__ ;
 cfg[ 2 ].bit.src_type    = __FrontEnd__ ;
 cfg[ 2 ].bit.no_channels = __NoChannels__ ;
 cfg[ 2 ].bit.no_samples  = __NoSamples__ ;
 cfg[ 2 ].bit.io_type     = __Auto__ ;
 cfg[ 2 ].bit.format_id   = __ByPass__ ;
 cfg[ 3 ].all             = __AutoTRG__ ;
 sleep( 5 ); 

   if( ROD_Config( rod, 0, ( word32 )( &cfg[ 0 ] )) != FAIL ){
   sleep( 5 );
   Module_Command( rod, 0, RUN, status );
   sleep( 10 );
   Module_Command( rod, 0, PAUSE, status);
   sleep( 5 );
   Module_Command( rod, 0, CONTINUE, status);
   sleep( 10 );
   Module_Command( rod, 0, STOP, status );
   if( ROD_Sampling( rod, 0, &evt_ba ) == SUCCESS )
     Show_Event( evt_ba );
    
   sleep( 5 );
   cfg[ 1 ].bit.src_type    = __Controller__ ;
   cfg[ 1 ].bit.io_mode     = __Driver__ ;
   cfg[ 1 ].bit.io_type     = __VME__ ;
   ROD_Config( rod, 0, ( word32 )( &cfg[ 0 ] ));
   sleep( 2 );
   Module_Command( rod, 0, RUN, status );
   sleep( 10 );
   Module_Command( rod, 0, PAUSE, status);
   sleep( 5 );
   Module_Command( rod, 0, CONTINUE, status);
   sleep( 10 );
   Module_Command( rod, 0, STOP, status );
   if( ROD_Sampling( rod, 0, &evt_ba ) == SUCCESS )
     Show_Event( evt_ba );

 }

 FEnd_BroadCast( rod, SHUTDOWN );
 Module_BroadCast( rod, SHUTDOWN );

 if( ROD_Close( rod ) != SUCCESS ){
   printf("\n[ %-30s ]\n", "ROD Close: FAIL" );
   fflush( stdout );
   return( FAIL );
 }
 printf("\nBye, ;-)\n");
 return( SUCCESS );
 
}

int
Show_Event( word32 evt_ba ){
word32  *evt, ii;

 evt = ( word32* )evt_ba;
 for( ii = 0 ; ii< 20; ii++ ){
   printf("\n[ %02d ][ $%08x ]", ii, evt[ ii ] );
 }
 return( SUCCESS );
}
/* ------------------------------------------------------------------------ */


