/**
    $Header: TileCal ROD Controller Main Thread.
    Created & Maintained by JB. Juanba.Romance@ific.uv.es $

    11/October/99:
    Front-End Implementation Starts
    
    10/December/99:
    FrontEnd  Main Thread State Machine Starts.
    Front-End Configuration Decoding Starts
**/

#include "ROD.h"

/* Highlighting EveryWhere; */
char bd[ ] = { 27, 91, 49, 109, 0 };
char us[ ] = { 27, 91, 49, 27, 91, 52, 109,0 };
char atoff[ ] = { 27, 91, 48, 109, 0 };

int
main( int argc, char *argv[ ] ){
ROD *rod;
Config_Word cfg[ __ConfigPackSize__ +1 ];
word32 *l_csr, *r_csr, jj =CLEAR, ii, set=SET; 
FEnd_stat *fe_stat;

 if( ROD_Open( &rod ) != SUCCESS ){
   printf("\n[ %-30s ]\n", "ROD Open: FAIL" );
   if( ROD_Close( rod ) != SUCCESS ){
     printf("\n[ %-30s ]\n", "ROD Close: FAIL" );
     fflush( stdout );
     return( FAIL );
   }
   printf("\nBye, ;-)\n");
   fflush( stdout );
   return( FAIL );
 }
#ifdef VERBOSE
 printf("\n[ %-20s ]", "ROD Open: SUCESS");
 fflush( stdout );
#endif
 r_csr = rod->hardware->ctrl.r_csr;
 l_csr = rod->hardware->ctrl.l_csr;
 l_csr[ 0 ] = MASK_COMMAND;
 printf("\n[ FrontEnd: Enter on CTRL-Loop ]" );
 fflush( stdout );
 fe_stat = &( rod->fe_stat );
 fe_stat->bit.stop = SET;


 /* Front-End Loop ------------------------------------------------------- */
 while( set ){
   usleep( 200000 ); /* Command Response Timing 200msec */
   
   ++jj;
   if( !( jj%5 ) ){
     printf("\n[ FrontEnd: CTRL-Loop: Waiting Command ]" );
     fflush( stdout );
   }
   
   if( l_csr[ 0 ] == MASK_COMMAND )
     continue;

   switch( l_csr[ 0 ] ){

   case RUN:
     printf("\n[RUN][ Received ]");
     if( fe_stat->bit.config == CLEAR ){
       printf("\n[WARNING][FrontEnd System: NOT Configured]");
       r_csr[ 1 ] = ACK_1;
       break;
     }
     if( fe_stat->bit.run == SET ){
       printf("\n[WARNING][FrontEnd Injection System: Already Running]");
       r_csr[ 1 ] = ACK_2;
       break;
     }
     
     if( fe_stat->bit.stop == SET ){
       printf("\n[WARNING][FrontEnd Injection System: Down]");
       r_csr[ 1 ] = ACK_3;
       break;
     }
     /* Real Action Begins ----- */
     
     if( ROD_Run( rod ) == SUCCESS ){
       fe_stat->bit.run = SET;
       fe_stat->bit.stop = CLEAR;
       fe_stat->bit.pause = CLEAR;
       printf("\n[ %-30s ]","ROD: Software: Injection: RUN: SUCESS" );
       r_csr[ 1 ] = RUN;
     }
     
     /* --------------------------- */
     break;
     
   case PAUSE:
     printf("\n[PAUSE][ Received ]");
     if( fe_stat->bit.stop == SET ){
       printf("\n[WARNING][Injection System: Down]");
       r_csr[ 1 ] = ACK_3;
       break;
     }
     if( fe_stat->bit.run == CLEAR ){
       printf("\n[WARNING][Injection System: NOT Running]");
       r_csr[ 1 ] = ACK_4;
       break;
     }
     /* Pause Data Injection --- */

     fe_stat->bit.pause = SET;
     fe_stat->bit.run   = CLEAR;
     Pause_Software( rod->software );
		    
     /* ------------------------ */
     printf("\n[ %-30s ]","ROD: Software: Injection: PAUSE: SUCESS" );
     
     break;

   case CONTINUE:
     printf("\n[CONTINUE][ Received ]");
     if( fe_stat->bit.stop == SET ){
       printf("\n[WARNING][Injection System: Down]");
       r_csr[ 1 ] = ACK_3;
       break;
     }
     if( ( fe_stat->bit.run == CLEAR )&&( fe_stat->bit.pause == CLEAR )){
       printf("\n[WARNING][Injection System: NOT Running]");
       r_csr[ 1 ] = ACK_4;
       break;
     }
     /* Continue Data Injection --- */

     fe_stat->bit.pause = CLEAR;
     fe_stat->bit.run  = SET;
     Continue_Software( rod->software );
     printf("\n[ %-30s ]","ROD: Software: Injection: CONTINUE: SUCESS" );
     r_csr[ 1 ] = CONTINUE;
     /* --------------------------- */
     break;
     
   case CONFIG:
     printf("\n[CONFIG][ Received ]");
     if( fe_stat->bit.run == SET ){
       printf("\n[WARNING][Injection System: Running: STOP/PAUSE Before]");
       r_csr[ 1 ] = ACK_7;
       break;
     }
     cfg[ 0 ].all = l_csr[ __cfgOffset__ ];
     cfg[ 1 ].all = l_csr[ __cfgOffset__ +1 ];
     cfg[ 2 ].all = l_csr[ __cfgOffset__ +2 ];
     cfg[ 3 ].all = l_csr[ __cfgOffset__ +3 ];
     for( ii = 0; ii <  ( __ConfigPackSize__ +1 ); ii++ ){
       printf("\n[ %-30s ][ $%08x ]", "Config word", 
	      ( unsigned )( cfg[ ii ].all ) );
     }
     /* Configure Data Injection System --- */
     
     if( ROD_Config( rod, ( word32* )( &( cfg[ 0 ].all ) ) ) == SUCCESS ){
       printf("\n[ %-30s ]", "ROD: Software: Injection CONFIG: SUCESS" );
       fflush( stdout );
       fe_stat->bit.config = SET;
       fe_stat->bit.stop = CLEAR;
       r_csr[ 1 ] = CONFIG;
     }
     
     /* ----------------------------------- */
     break;

   case STOP:
     printf("\n[STOP][ Received ]");
     if( fe_stat->bit.stop == SET ){
       printf("\n[WARNING][Injection System: NOT Running]");
       r_csr[ 1 ] = ACK_4;
       fflush( stdout );
       break;
     }
     /* Kill Data Injection --------------- */

     if( ROD_Stop( rod ) == SUCCESS ){
       printf("\n[ %-30s ]", "ROD: Software: Injection STOP: SUCESS" );
       fflush( stdout );
       fe_stat->bit.run = CLEAR;
       fe_stat->bit.stop = SET;
       fe_stat->bit.pause = CLEAR;
       r_csr[ 1 ] = STOP;
     }
     
     /* ----------------------------------- */
     break;

   case SHUTDOWN:
     printf( "\n\n[SHUTDOWN][ Received ]\n[FrontEnd: Going Down]\n" );
     set = CLEAR;
     break;
   default:
     printf( "[ %-30s ]", "Unknown Command" );
   }
   l_csr[ 0 ] = MASK_COMMAND;
   r_csr[ 0 ] = CMD_RECEIVED;
 }
 /* ---------------------------------------------------------------------- */
 
 if( ROD_Close( rod ) != SUCCESS ){
   printf("\n[ %-30s ]\n", "ROD Close: FAIL" );
   fflush( stdout );
   return( FAIL );
 }
#ifdef VERBOSE
 else{
   printf("\n[ %-30s ]\n", "ROD Close: SUCESS" );
   fflush( stdout );
 }
#endif
 printf("\nBye, ;-)\n");
 return( SUCCESS );

}


