#if defined( LinuxPCBit3 )
#include "RODslink.h"

int
Open_RODSlink( ROD_slink **rod_slink  ){
int status = SUCCESS;

 if( *rod_slink != NULL ){
   printf("\nROD_SLINK: Device alloc: Already DONE" );
   fflush( stdout );
   return( FAIL );
 }
 /* Slink Chipset ----------------------------------------------- */
 ( *rod_slink ) = ( ROD_slink* )malloc( sizeof( ROD_slink ) );
 if( *rod_slink == NULL ){
   printf("\nROD_SLINK: Slink Device Alloc: FAIL" );
   fflush( stdout );
   return( FAIL );
 }
 
 if( SLink_Open( &( ( *rod_slink )->slink_dev ) ) != SUCCESS ){
   printf("\nROD_SLINK: Slink Device Open: FAIL" );
   fflush( stdout );
   return( FAIL );
 }
 SLink_Init( &( ( *rod_slink )->slink_dev ) );

 /* Slink-DMA Buffer -------------------------------------------- */
 if( SlinkDMA_Open( &( ( *rod_slink )->dma_dev ) ) != SUCCESS ){
   printf("\nROD_SLINK: DMA-Slink Device Open: FAIL" );
   fflush( stdout );
   return( FAIL );
 }
 if( SlinkDMA_Alloc( &( ( *rod_slink )->dma_dev ) ) != SUCCESS ){
   SlinkDMA_Close( &( ( *rod_slink )->dma_dev ) );
   printf("\nROD_SLINK: DMA-Slink Device Alloc: FAIL" );
   fflush( stdout );
   return( FAIL );
 }

 if( SlinkDMA_Map( &( ( *rod_slink )->dma_dev ) ) != SUCCESS ){
   SlinkDMA_Release( &( *rod_slink )->dma_dev   );
   SlinkDMA_Close  ( &( *rod_slink )->dma_dev   );
   printf("\nROD_SLINK: DMA-Slink Device Map: FAIL" );
   fflush( stdout );
   return( FAIL );
 }

 return( status );

}

int
Close_RODSlink( ROD_slink *rod_slink  ){
int status = SUCCESS;

 if( rod_slink == NULL ){
   printf("\nRODSlink: Slink Device Close: Already Closed" );
   return( FAIL );
 }
 if( SLink_Close( &( rod_slink->slink_dev ) ) != SUCCESS ){
   printf("\nSlinklib: Slink Device Close: FAIL" );
   fflush( stdout );
   status = FAIL;
 }
 SlinkDMA_Unmap  ( &rod_slink->dma_dev   );
 SlinkDMA_Release( &rod_slink->dma_dev   );
 SlinkDMA_Close  ( &rod_slink->dma_dev   );
 free( rod_slink );
 rod_slink = NULL;
 return( status );

}

int
SetUp_RODSlink ( ROD_slink  *rod_slink  ){
int status = SUCCESS;

 return( status );

}

#endif
