/* ----------- Only will be Available for MVME2604 Host Target ------------- */
#if defined( PowerPC_Lynx3_0  )

/*+ Code Development has been moved to IUnit which drives and/or 
   uses Slink Port and therefore the RODSlink Data Object. +*/

#include "RODslink.h"


int
Open_RODSlink( RODSlink **dev ){
int status = SUCCESS;

 *dev = ( RODSlink* )malloc( sizeof( RODSlink ) );
 if( *dev == NULL ){
   printf("\n[ %-40s ]","SlinkHardware: Alloc: FAIL" );
   fflush( stdout );
   status = FAIL;
 }
 if( Slink_Open( &( ( *dev )->slink_dev ) ) != SUCCESS ){
   printf("\n[ %-40s ]","SlinkHardware: Open: FAIL" );
   Slink_Close( &( ( *dev )->slink_dev ) );
   fflush( stdout );
   status = FAIL;
 }
 else{
#ifdef VERBOSE
   printf("\n[ %-40s ]","SlinkHardware: Open: SUCESS" );
   fflush( stdout );
#endif
   if( Slink_Init( &( ( *dev )->slink_dev ) ) != SUCCESS ){
     Slink_Close( &( ( *dev )->slink_dev ) );
     printf("\n[ %-40s ]","SlinkHardware: Slink-Dev init: FAIL" );
     fflush( stdout );
     status = FAIL;
   }
 }
 return( status ); 

}


int
Close_RODSlink( RODSlink *dev ){
int status = SUCCESS;

 if( dev != NULL ){
   Slink_Close( &( dev->slink_dev ) );
   free( dev );
 }
 else{
   printf("\n[ %-40s ]","SlinkHardware: Oooooops Null Pointer" );
   fflush( stdout );
   status = FAIL;
 }
 return( status );
 
}

#endif
/* ------------------------------------------------------------------------- */
