/*************
    $Header: RODSoftware object for the ROD-Module Application. Interface with the RODMachine object. Created & Maintaned by JB. Juanba.Romance@ific.uv.es $

    10/December/99: Return And status modes Recoded
*************/
#include "RODsoftware.h"

int
Open_Software( ROD_Software **rod_soft, w32 csr_addr, w32 sys_addr ){
int status = FAIL;

   
 *rod_soft = ( ROD_Software* )malloc( sizeof( ROD_Software ) );
 if( *rod_soft == NULL ){
   printf("\n[ROD: Software: Alloc: FAIL");
   fflush( stdout );
   return( status );
 }
 ( *rod_soft )->machine = NULL;
 if(Machine_Open( &(( *rod_soft )->machine ), csr_addr, sys_addr) != SUCCESS){
   printf("\n[ ROD: Machine: Open: FAIL" );
   fflush( stdout );
   return( status );
 }
 status = SUCCESS;
 return( status );

}


int
Close_Software( ROD_Software *rod_soft ){
int status = FAIL;

 if( rod_soft == NULL ){ 
   printf("\n[ ROD: Software: Oooooops Null Pointer" );
   fflush( stdout );
   return( status );
 }
 if( rod_soft->machine != NULL ){
   if( Machine_Close( rod_soft->machine ) != SUCCESS ){
     printf("\n[ ROD: Machine: Close: FAIL" );
   }
 }
 free( rod_soft );
#ifdef VERBOSE
 printf("\n[ ROD: Software: Close: SUCESS" );
#endif
 status = SUCCESS;
 return( status );

}


int
Run_Software( ROD_Software *rod_soft ){
int status = FAIL;

 if( rod_soft == NULL ){
   printf("\n[ ROD: Software: Oooooops Null Pointer" );
   return( status );
 }
 if( Machine_RunBaby( rod_soft->machine ) != SUCCESS ){
   printf("\n[ ROD: Machine: Run: FAIL" );
   return( status );
 }
 status = SUCCESS;
 return( status );

}


int
Dump_Software( ROD_Software *rod_soft ){
int status = FAIL;

 if( rod_soft == NULL ){
   printf("\[ ROD: Software: Oooooops Null Pointer ]" );
   return( status );
 }
 if( rod_soft->machine == NULL ){
   printf("\n[ ROD: Software: Machine: Oooooops Null Pointer ]" );
   return( status );
 }
 if( Machine_Dump( rod_soft->machine ) != SUCCESS ){
   printf("\n[ ROD: Machine: Run: FAIL ]" );
   return( status );
 }
 status = SUCCESS;
 return( status );

}

int
Config_Software( ROD_Software *rod_soft, w32 *cfg_word, w32 *obj_info ){
int status =FAIL;
Config_Word cfg;
w32 cfg_data[ 40 ];
IOParams *io_par;

 if( rod_soft == NULL ){
   printf("\n[ ROD: Software: Oooooops Null Pointer ]" );
   return( status );
 }
 /*
   --= "info" pointer format =-- Input Pointer
   ________________ __Ptr. Index____________________________
   Local info:     |  
   Input Buffer  |  [0][1][2] vaddr, dev_size, paddr
   OutPut Buffer |  [3][4][5] idem than above
   LocalCSR      |  [6]       vaddr of Local CSR
   Remote info:    |
   DMAObjects    |  [7][8] vaddr of Input/OutPut Buffers
   RemoteCSR     |  [9]    vaddr of Remote CSR
   SlinkObject     |  [10]   vaddr of RODSlink object 
   ---------------------------------------------------------

   --= "cfg_data" pointer format =-- Output Pointer
   _______________________Ptr. Index________________________________
   cfg_word            | [0][1] IUnit, OUnit
   IUnit Hardware Info | [2][3][4][5][6][7][8][9][10] See Below
   OUnit Hardware Info | [11][12][13][14][15][16][17][18] See Below
   Trigger Config      | [19]
   Slink Device Vaddr  | [20]
   -----------------------------------------------------------------
 */
 
 cfg_data[ 0 ] = cfg_word[ 0 ];
 cfg_data[ 1 ] = cfg_word[ 1 ];
 cfg.all = cfg_word[ 0 ];
 io_par = ( IOParams* )( &cfg_data[ 2 ] );
 /* IUnit Parametters */
 io_par->io_type    = cfg.bit.io_type;
 io_par->io_mode    = cfg.bit.io_mode;
 io_par->buffer     = obj_info[ 0  ];
 io_par->paddr      = obj_info[ 2  ];
 io_par->size       = obj_info[ 1  ];
 io_par->evt_size   = cfg.bit.no_samples*cfg.bit.no_channels;
 io_par->lcsr_vaddr = obj_info[ 6  ];
 io_par->dma_dev    = obj_info[ 7  ];
 io_par->rcsr_vaddr = obj_info[ 9  ];
 io_par->slink_addr = obj_info[ 10 ];

 /* OUnit Parametters */
 cfg.all = cfg_word[ 1 ];
 io_par = ( IOParams* )( &cfg_data[ 12 ] );
 io_par->io_type    = cfg.bit.io_type;
 io_par->io_mode    = cfg.bit.io_mode;
 io_par->buffer     = obj_info[ 3  ];
 io_par->paddr      = obj_info[ 5  ];
 io_par->size       = obj_info[ 4  ];
 io_par->evt_size   = cfg.bit.no_samples*cfg.bit.no_channels;
 io_par->lcsr_vaddr = obj_info[ 6  ];
 io_par->dma_dev    = obj_info[ 8  ];
 io_par->rcsr_vaddr = obj_info[ 9  ];

 cfg_data[ 19 ]     = cfg_word[ 2  ];
 
 if( Machine_Config( rod_soft->machine, cfg_data  ) != SUCCESS ){
   printf("\n[ ROD: Machine: Run: FAIL ]" );
   return( status );
 }
 status = SUCCESS;
 return( status );

}
